#!/bin/sh
#BK 2004
#called from color.tcl, params passed in:
# $1=width $2=height $3="begincolor endcolor patternkind"
#where patternkind is a value from -1 to 6.
#this script must return the image in base64 encoded form to stdout.

{ #suppress any stdout, errout.

BEGINCLR="`echo -n $3 | cut -f 1 -d " "`"
ENDCLR="`echo -n $3 | cut -f 2 -d " "`"
PATKIND=`echo -n $3 | cut -f 3 -d " "`

#colors can arrive either as text, for example "white" or rgb, for example "#6780ff"
#the later needs to be reformatted...
echo $BEGINCLR | grep "#"
if [ $? -eq 0 ];then
REDCLR="`echo $BEGINCLR | cut -b 2,3`"
GRNCLR="`echo $BEGINCLR | cut -b 4,5`"
BLUCLR="`echo $BEGINCLR | cut -b 6,7`"
BEGINCLR="rgb:${REDCLR}/${GRNCLR}/${BLUCLR}"
fi

echo $ENDCLR | grep "#"
if [ $? -eq 0 ];then
REDCLR="`echo $ENDCLR | cut -b 2,3`"
GRNCLR="`echo $ENDCLR | cut -b 4,5`"
BLUCLR="`echo $ENDCLR | cut -b 6,7`"
ENDCLR="rgb:${REDCLR}/${GRNCLR}/${BLUCLR}"
fi

IMGEFFECT="ppmrainbow -width=256 -height=256 $BEGINCLR $ENDCLR 2>/dev/null"
TYPEMSG="width=$1 height=$2 begincolor=$BEGINCLR endcolor=$ENDCLR kind=$PATKIND" 
IMGCUT=""

if [ $PATKIND -eq -1 ];then #no gradient um, NO, this removes background!
 #$4=$3
 #TYPEMSG="#-1=no gradient."
 ROTIMAGE=""
 IMGEFFECT="ppmmake $BEGINCLR $1 $2 2>/dev/null"
fi
if [ $PATKIND -eq 0 ];then #left to right
 #TYPEMSG="#0=left to right"
 IMGCUT=" pnmcut 0 0 128 256 |"
 ROTIMAGE=""
fi
if [ $PATKIND -eq 1 ];then #top to bottom
 #TYPEMSG="#1=top to bottom"
 ROTIMAGE="pnmrotate -noantialias 90 2>/dev/null|"
 IMGCUT=" pnmcut 0 0 256 128 |"
fi
if [ $PATKIND -eq 2 ];then #to bottom right
 #TYPEMSG="#2=to bottom right"
 ROTIMAGE="pnmrotate -noantialias 45 2>/dev/null|"
 IMGCUT=" pnmcut 128 64 64 64 |"
fi
if [ $PATKIND -eq 3 ];then #to bottom left
 #TYPEMSG="#3=to bottom left"
 ROTIMAGE="pnmrotate -noantialias 45 2>/dev/null|"
 IMGCUT=" pnmcut 64 128 64 64 |"
fi
if [ $PATKIND -eq 4 ];then #to centre, vertical bar
 #TYPEMSG="#4=to centre, vertical bar"
 IMGEFFECT="ppmrainbow -width=256 -height=256 $BEGINCLR $ENDCLR 2>/dev/null"
 ROTIMAGE=""
fi
if [ $PATKIND -eq 5 ];then #to centre, horiz bar
 #TYPEMSG="#5=to centre, horiz bar"
 IMGEFFECT="ppmrainbow -width=256 -height=256 $BEGINCLR $ENDCLR 2>/dev/null"
 ROTIMAGE="pnmrotate -noantialias 90 2>/dev/null|"
fi
if [ $PATKIND -eq 6 ];then #to centre, circle
 #TYPEMSG="#6=to centre, circle"
 #i haven't done this one properly...
 #IMGEFFECT=""
 ROTIMAGE=""
fi
} > /dev/null 2>&1


echo "#!/bin/sh" >/tmp/runbkgrnd.sh
echo "$TYPEMSG" >>/tmp/runbkgrnd.sh
echo "${IMGEFFECT}|${ROTIMAGE}${IMGCUT} pnmscale -width=${1} -height=${2} 2>/dev/null| ppmquant 256 2>/dev/null| ppmtogif 2>/dev/null| mimencode" >>/tmp/runbkgrnd.sh
chmod 755 /tmp/runbkgrnd.sh > /dev/null 2>&1
exec /tmp/runbkgrnd.sh 2>/dev/null
