#!/bin/sh
# Image conversion utility which gives a base64-encoded gif image
# you may change this if you don't have ImageMagick installed (convert)
# but be sure to change its options (-despeckle, -dither, ...) in the code.
#
#convert $@ gif:- | mimencode

{ #group stars here. get rid of any possible stdout and sterr.

# BK no ImageMagick, using Netpbm package...
# need to separate out the fields in $@...
for ONEFIELD in $@
do
  #now can process the options...
  if [ "$CROP" = "yes" ];then #actually will do a resize, not a crop...
   CROP=""
   MODFIELD="`echo -n "$ONEFIELD" | tr "x" " "`"
   cropOPTION="pnmscale -xysize $MODFIELD 2>/dev/null|"
  fi
  if [ "$ONEFIELD" = "-crop" ];then
   CROP="yes"
  fi
  if [ "$TRANSPARENCY" = "yes" ];then
   TRANSPARENCY=""
   transparentOPTION=" -transparent=$ONEFIELD"
  fi
  if [ "$ONEFIELD" = "-transparency" ];then
   TRANSPARENCY="yes"
  fi
  if [ "$ONEFIELD" = "-despeckle" ];then
   despeckleOPTION=" pnmnlfilt 0.5 1.0 2>/dev/null|"
  fi
  if [ "$ONEFIELD" = "-emboss" ];then #actually will do anti-aliase, not emboss...
   embossOPTION=" pnmalias 2>/dev/null|"
  fi
  if [ "$ONEFIELD" = "-dither" ];then
   ditherOPTION=" ppmdither 2>/dev/null|"
  fi
  if [ "$ONEFIELD" = "-enhance" ];then #would like to de-jag the jagged edges...
   #note, this will have to be the final option.
   enhanceOPTION=" pnmsmooth 2>/dev/null|"
  fi
done
#drops out with $ONEFIELD is the filespec.


} > /dev/null 2>&1 #group ends here.

#have a problem, confuses the Ash interpreter if try to compose a long piped execution
#sequence here, so write it all to a file first...

echo "#!/bin/sh" >/tmp/runcv.sh
echo "anytopnm $ONEFIELD 2>/dev/null|${cropOPTION}${despeckleOPTION}${embossOPTION}${ditherOPTION}${enhanceOPTION}ppmquant 256 2>/dev/null|ppmtogif ${transparentOPTION} 2>/dev/null| mimencode" >>/tmp/runcv.sh
chmod 755 /tmp/runcv.sh > /dev/null 2>&1
exec /tmp/runcv.sh 2>/dev/null
